package com.moyoung.moyoung_ble_plugin.blescan;

import android.text.TextUtils;

import com.crrepa.ble.scan.bean.CRPScanDevice;
import com.crrepa.ble.scan.callback.CRPScanCallback;
import com.moyoung.moyoung_ble_plugin.base.BaseEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.ConstraintsMap;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.blescan.model.BleScanEvent;

import java.util.List;

public class BleScanEveChlHandler extends BaseEveChlHandler {
    private static final int SCAN_PERIOD = 10 * 1000;

    public void startScan() {
        bleClient.scanDevice(new CRPScanCallback() {
            @Override
            public void onScanning(CRPScanDevice device) {
                if (TextUtils.isEmpty(device.getDevice().getName())) {
                    return;
                }
                BleScanEvent bleScanEvent = BleScanEvent.covert(device);
                String jsonStr = GsonUtils.get().toJson(bleScanEvent, BleScanEvent.class);
                eventSink.success(jsonStr);
            }

            @Override
            public void onScanComplete(List<CRPScanDevice> list) {
                ConstraintsMap paramsMap = new ConstraintsMap();
//                paramsMap.putString(EVENT_MOYOUNG, "onScanComplete");
//                mActivity.runOnUiThread(() -> mEventSink.success(paramsMap.toMap()));
            }
        }, SCAN_PERIOD);
    }

}
