package com.moyoung.moyoung_ble_plugin.conn;

import android.util.Log;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.bean.CRPBloodOxygenInfo;
import com.crrepa.ble.conn.bean.CRPHistoryBloodOxygenInfo;
import com.crrepa.ble.conn.listener.CRPBloodOxygenChangeListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.ConnBloodOxygenBean;

import java.util.List;

class ConnBloodOxygenEveChlHandler extends BaseConnEveChlHandler {
    private final static String TAG = ConnBloodOxygenEveChlHandler.class.getSimpleName();

    @Override
    public void setConnListener(CRPBleConnection connection) {
        connection.setBloodOxygenChangeListener(new CRPBloodOxygenChangeListener() {
            @Override
            public void onContinueState(boolean continueState) {
                ConnBloodOxygenBean connBloodOxygenBean = new ConnBloodOxygenBean(true);
                connBloodOxygenBean.setContinueState(continueState);
                String boStr = GsonUtils.get().toJson(connBloodOxygenBean, ConnBloodOxygenBean.class);
                activity.runOnUiThread(() -> eventSink.success(boStr));
            }

            @Override
            public void onTimingMeasure(int timingMeasure) {
                ConnBloodOxygenBean connBloodOxygenBean = new ConnBloodOxygenBean(true);
                connBloodOxygenBean.setTimingMeasure(timingMeasure);
                String boStr = GsonUtils.get().toJson(connBloodOxygenBean, ConnBloodOxygenBean.class);
                activity.runOnUiThread(() -> eventSink.success(boStr));
            }

            @Override
            public void onBloodOxygen(int bloodOxygen) {
                ConnBloodOxygenBean connBloodOxygenBean = new ConnBloodOxygenBean(true);
                connBloodOxygenBean.setBloodOxygen(bloodOxygen);
                String boStr = GsonUtils.get().toJson(connBloodOxygenBean, ConnBloodOxygenBean.class);
                activity.runOnUiThread(() -> eventSink.success(boStr));
            }

            @Override
            public void onHistoryBloodOxygen(List<CRPHistoryBloodOxygenInfo> historyBOList) {
                ConnBloodOxygenBean connBloodOxygenBean = new ConnBloodOxygenBean(true);
                connBloodOxygenBean.setHistoryList(historyBOList);
                String boStr = GsonUtils.get().toJson(connBloodOxygenBean, ConnBloodOxygenBean.class);
                activity.runOnUiThread(() -> eventSink.success(boStr));
            }

            @Override
            public void onContinueBloodOxygen(CRPBloodOxygenInfo crpBloodOxygenInfo) {
                ConnBloodOxygenBean connBloodOxygenBean = new ConnBloodOxygenBean(true);
                connBloodOxygenBean.setContinueBO(crpBloodOxygenInfo);
                String boStr = GsonUtils.get().toJson(connBloodOxygenBean, ConnBloodOxygenBean.class);
                activity.runOnUiThread(() -> eventSink.success(boStr));
            }
        });


    }

}

