package com.moyoung.moyoung_ble_plugin.conn;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.bean.CRPBloodPressureInfo;
import com.crrepa.ble.conn.bean.CRPHistoryBloodPressureInfo;
import com.crrepa.ble.conn.listener.CRPBloodPressureChangeListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.ConnBloodPressureBean;

import java.util.List;

public class ConnBloodPressureEveChlHandler extends BaseConnEveChlHandler {
    private final static String TAG = ConnHeartRateEveChlHandler.class.getSimpleName();

    @Override
    public void setConnListener(CRPBleConnection connection) {
        connection.setBloodPressureChangeListener(
                new CRPBloodPressureChangeListener() {
                    @Override
                    public void onContinueState(boolean continueState) {
                        ConnBloodPressureBean connBloodPressureBean = new ConnBloodPressureBean(true);
                        connBloodPressureBean.setContinueState(continueState);
                        String bpStr = GsonUtils.get().toJson(connBloodPressureBean, ConnBloodPressureBean.class);
                        activity.runOnUiThread(() -> eventSink.success(bpStr));
                    }

                    @Override
                    public void onBloodPressureChange(int bloodPressure, int bloodPressure1) {
                        ConnBloodPressureBean connBloodPressureBean = new ConnBloodPressureBean(true);
                        connBloodPressureBean.setBloodPressureChange(bloodPressure);
                        connBloodPressureBean.setBloodPressureChange1(bloodPressure1);
                        String bpStr = GsonUtils.get().toJson(connBloodPressureBean, ConnBloodPressureBean.class);
                        activity.runOnUiThread(() -> eventSink.success(bpStr));
                    }

                    @Override
                    public void onHistoryBloodPressure(List<CRPHistoryBloodPressureInfo> historyBPList) {
                        ConnBloodPressureBean connBloodPressureBean = new ConnBloodPressureBean(true);
                        connBloodPressureBean.setHistoryBPList(historyBPList);
                        String bpStr = GsonUtils.get().toJson(connBloodPressureBean, ConnBloodPressureBean.class);
                        activity.runOnUiThread(() -> eventSink.success(bpStr));
                    }

                    @Override
                    public void onContinueBloodPressure(CRPBloodPressureInfo crpBloodPressureInfo) {
                        ConnBloodPressureBean connBloodPressureBean = new ConnBloodPressureBean(true);
                        connBloodPressureBean.setContinueBP(crpBloodPressureInfo);
                        String bpStr = GsonUtils.get().toJson(connBloodPressureBean, ConnBloodPressureBean.class);
                        activity.runOnUiThread(() -> eventSink.success(bpStr));
                    }
                }
        );
    }


}
