package com.moyoung.moyoung_ble_plugin.conn;

import android.util.Log;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.listener.CRPFileTransListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnLazyEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.CRPContactBean;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;

class ConnContactAvatarLazyEveChlHandler extends BaseConnLazyEveChlHandler {
    Map<String, Object> mapStr = new HashMap<>();
    private final static String TAG = ConnContactAvatarLazyEveChlHandler.class.getSimpleName();

    @Override
    public void setLazyConnListener(CRPBleConnection connection, MethodCall call) {
        String jsonStr = call.argument("contactBean");
        Log.d(TAG, jsonStr);
        CRPContactBean contactBean = GsonUtils.get().fromJson(jsonStr, CRPContactBean.class);
        connection.sendContactAvatar(contactBean.getId(),  contactBean.getAvatar(),
                contactBean.getTimeout(),  new CRPFileTransListener() {
            @Override
            public void onTransProgressStarting() {
                mapStr.put("isError", false);
                mapStr.put("progress", 1);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }

            @Override
            public void onTransProgressChanged(int progress) {
                mapStr.put("isError", false);
                mapStr.put("progress", progress);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }

            @Override
            public void onTransCompleted() {
                mapStr.put("isError", false);
                mapStr.put("progress", 100);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }

            @Override
            public void onError(int i) {
                mapStr.put("isError", true);
                mapStr.put("progress", 0);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }
        });

    }
}

