package com.moyoung.moyoung_ble_plugin.conn;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.listener.CRPBleECGChangeListener;
import com.crrepa.ble.conn.type.CRPEcgMeasureType;
import com.crrepa.ble.conn.type.CRPWatchFaceType;
import com.moyoung.moyoung_ble_plugin.base.BaseConnLazyEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.ConnEGCBean;

import java.util.Date;

import io.flutter.plugin.common.MethodCall;

class ConnEGCEveChlHandler extends BaseConnLazyEveChlHandler {
    private final static String TAG = ConnEGCEveChlHandler.class.getSimpleName();

    @Override
    public void setLazyConnListener(CRPBleConnection connection, MethodCall call) {
        String ecgMeasureType = call.argument("ecgMeasureType");
        ecgMeasureType = ecgMeasureType == null ? CRPEcgMeasureType.TI.toString() : ecgMeasureType;
        
        connection.setECGChangeListener(new CRPBleECGChangeListener() {
            @Override
            public void onECGChange(int[] ECGChangeInts) {
                ConnEGCBean connEGCBean = new ConnEGCBean(true);
                connEGCBean.setInts(ECGChangeInts);
                String egcStr = GsonUtils.get().toJson(connEGCBean, ConnEGCBean.class);
                activity.runOnUiThread(() -> eventSink.success(egcStr));
            }

            @Override
            public void onMeasureComplete() {
                ConnEGCBean connEGCBean = new ConnEGCBean(true);
                connEGCBean.setMeasureComplete(100);
                String egcStr = GsonUtils.get().toJson(connEGCBean, ConnEGCBean.class);
                activity.runOnUiThread(() -> eventSink.success(egcStr));
            }

            @Override
            public void onTransCpmplete(Date date) {
                ConnEGCBean connEGCBean = new ConnEGCBean(true);
                connEGCBean.setDate(date);
                String egcStr = GsonUtils.get().toJson(connEGCBean, ConnEGCBean.class);
                activity.runOnUiThread(() -> eventSink.success(egcStr));
            }

            @Override
            public void onCancel() {
                ConnEGCBean connEGCBean = new ConnEGCBean(true);
                connEGCBean.setCancel(true);
                String egcStr = GsonUtils.get().toJson(connEGCBean, ConnEGCBean.class);
                activity.runOnUiThread(() -> eventSink.success(egcStr));
            }

            @Override
            public void onFail() {
                ConnEGCBean connEGCBean = new ConnEGCBean(true);
                connEGCBean.setFail(true);
                String egcStr = GsonUtils.get().toJson(connEGCBean, ConnEGCBean.class);
                activity.runOnUiThread(() -> eventSink.success(egcStr));
            }
        }, CRPEcgMeasureType.valueOf(ecgMeasureType));
    }


}

