package com.moyoung.moyoung_ble_plugin.conn;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.bean.CRPWatchFaceBackgroundInfo;
import com.crrepa.ble.conn.listener.CRPFileTransListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnLazyEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.BitmapUtils;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.CRPWatchFaceBgBean;

import java.util.HashMap;
import java.util.Map;

import android.graphics.Bitmap;
import android.util.Log;


import io.flutter.plugin.common.MethodCall;

class ConnFileTransLazyEveChlHandler extends BaseConnLazyEveChlHandler {
    private final static String TAG = ConnFileTransLazyEveChlHandler.class.getSimpleName();

    @Override
    public void setLazyConnListener(CRPBleConnection connection, MethodCall call) {
        Map<String, Object> mapStr = new HashMap<>();
        String jsonStr = call.argument("watchFaceBackgroundInfo");
        CRPWatchFaceBgBean watchFaceBgBean=GsonUtils.get().fromJson(jsonStr, CRPWatchFaceBgBean.class);
        Bitmap bitmap = watchFaceBgBean.getBitmap();
        bitmap = BitmapUtils.resizeBitmap(bitmap,240, 240);
        CRPWatchFaceBackgroundInfo backgroundInfo = new CRPWatchFaceBackgroundInfo(bitmap,watchFaceBgBean.getThumBitmap(),watchFaceBgBean.getType());

        connection.sendWatchFaceBackground(backgroundInfo, new CRPFileTransListener() {

            @Override
            public void onTransProgressStarting() {
                mapStr.clear();
                mapStr.put("isError", false);
                mapStr.put("progress", 1);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }

            @Override
            public void onTransProgressChanged(int progress) {
                mapStr.clear();
                mapStr.put("isError", false);
                mapStr.put("progress", progress);
                Log.d(TAG, "onTransProgressChanged: -----"+mapStr);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }

            @Override
            public void onTransCompleted() {
                mapStr.clear();
                mapStr.put("isError", false);
                mapStr.put("progress", 100);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }

            @Override
            public void onError(int i) {
                mapStr.clear();
                mapStr.put("flag", false);
                mapStr.put("value", i);
                Log.d(TAG, "onError: -----"+mapStr);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }
        });
    }
}

