package com.moyoung.moyoung_ble_plugin.conn;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.bean.CRPHeartRateInfo;
import com.crrepa.ble.conn.bean.CRPHistoryHeartRateInfo;
import com.crrepa.ble.conn.bean.CRPMovementHeartRateInfo;
import com.crrepa.ble.conn.listener.CRPHeartRateChangeListener;
import com.crrepa.ble.conn.type.CRPHistoryDynamicRateType;
import com.moyoung.moyoung_ble_plugin.base.BaseConnEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.ConnHeartRateBean;

import java.util.List;
import android.util.Log;

class ConnHeartRateEveChlHandler extends BaseConnEveChlHandler {
    private final static String TAG = ConnHeartRateEveChlHandler.class.getSimpleName();

    @Override
    public void setConnListener(CRPBleConnection connection) {
        connection.setHeartRateChangeListener(new CRPHeartRateChangeListener() {
            @Override
            public void onMeasuring(int measuring) {
                ConnHeartRateBean connHeartRateBean=new ConnHeartRateBean(true);
                connHeartRateBean.setMeasuring(measuring);
                String heartRateStr=GsonUtils.get().toJson(connHeartRateBean, ConnHeartRateBean.class);
                activity.runOnUiThread(() -> eventSink.success(heartRateStr));
            }

            @Override
            public void onOnceMeasureComplete(int onceMeasureComplete) {
                ConnHeartRateBean connHeartRateBean=new ConnHeartRateBean(true);
                connHeartRateBean.setOnceMeasureComplete(onceMeasureComplete);
                String heartRateStr=GsonUtils.get().toJson(connHeartRateBean, ConnHeartRateBean.class);
                Log.d(TAG, "onOnceMeasureComplete: "+heartRateStr);
                activity.runOnUiThread(() -> eventSink.success(heartRateStr));
            }

            @Override
            public void onHistoryHeartRate(List<CRPHistoryHeartRateInfo> historyHRList) {
                ConnHeartRateBean connHeartRateBean=new ConnHeartRateBean(true);
                connHeartRateBean.setHistoryHRList(historyHRList);
                String heartRateStr=GsonUtils.get().toJson(connHeartRateBean, ConnHeartRateBean.class);
                activity.runOnUiThread(() -> eventSink.success(heartRateStr));
            }

            @Override
            public void onMeasureComplete(CRPHistoryDynamicRateType crpHistoryDynamicRateType,
                                          CRPHeartRateInfo crpHeartRateInfo) {
                ConnHeartRateBean connHeartRateBean=new ConnHeartRateBean(true);
                connHeartRateBean.setHistoryDynamicRateType(crpHistoryDynamicRateType);
                connHeartRateBean.setMeasureComplete(crpHeartRateInfo);
                String heartRateStr=GsonUtils.get().toJson(connHeartRateBean, ConnHeartRateBean.class);
                activity.runOnUiThread(() -> eventSink.success(heartRateStr));
            }

            @Override
            public void on24HourMeasureResult(CRPHeartRateInfo crpHeartRateInfo) {
                ConnHeartRateBean connHeartRateBean=new ConnHeartRateBean(true);
                connHeartRateBean.setHour24MeasureResult(crpHeartRateInfo);
                String heartRateStr=GsonUtils.get().toJson(connHeartRateBean, ConnHeartRateBean.class);
                activity.runOnUiThread(() -> eventSink.success(heartRateStr));
            }

            @Override
            public void onMovementMeasureResult(List<CRPMovementHeartRateInfo> movementMeasureList) {
                ConnHeartRateBean connHeartRateBean=new ConnHeartRateBean(true);
                connHeartRateBean.setMovementList(movementMeasureList);
                String heartRateStr=GsonUtils.get().toJson(connHeartRateBean, ConnHeartRateBean.class);
                activity.runOnUiThread(() -> eventSink.success(heartRateStr));
            }
        });
    }

}

