package com.moyoung.moyoung_ble_plugin.conn;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.bean.CRPStepInfo;
import com.crrepa.ble.conn.listener.CRPStepChangeListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.ConnStepChangeBean;

class ConnStepChangeEveChlHandler extends BaseConnEveChlHandler {
    private final static String TAG = ConnStepChangeEveChlHandler.class.getSimpleName();

    @Override
    public void setConnListener(CRPBleConnection connection) {
        connection.setStepChangeListener(new CRPStepChangeListener() {
            @Override
            public void onStepChange(CRPStepInfo crpStepInfo) {
                ConnStepChangeBean stepChangeBean = new ConnStepChangeBean(true);
                stepChangeBean.setStepInfo(crpStepInfo);
                String stepStr = GsonUtils.get().toJson(stepChangeBean, ConnStepChangeBean.class);
                activity.runOnUiThread(() -> eventSink.success(stepStr));
            }

            @Override
            public void onPastStepChange(int past, CRPStepInfo pastStepInfo) {
                ConnStepChangeBean stepChangeBean = new ConnStepChangeBean(true);
                stepChangeBean.setPast(past);
                stepChangeBean.setPastStepInfo(pastStepInfo);
                String stepStr = GsonUtils.get().toJson(stepChangeBean, ConnStepChangeBean.class);
                activity.runOnUiThread(() -> eventSink.success(stepStr));
            }
        });
    }

}
