package com.moyoung.moyoung_ble_plugin.conn;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.bean.CRPHistoryTrainingInfo;
import com.crrepa.ble.conn.bean.CRPTrainingInfo;
import com.crrepa.ble.conn.listener.CRPTrainingChangeListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.ConnTrain;

import java.util.List;

public class ConnTrainHandler extends BaseConnEveChlHandler {
    private final static String TAG = ConnTempChangeHandler.class.getSimpleName();
    ConnTrain connTrain = new ConnTrain();
    @Override
    public void setConnListener(CRPBleConnection connection) {
        connection.setTrainingListener(new CRPTrainingChangeListener() {
            @Override
            public void onHistoryTrainingChange(List<CRPHistoryTrainingInfo> historyTrainList) {
                connTrain.setHistoryTrainList(historyTrainList);
                String jsonStr = GsonUtils.get().toJson(connTrain, ConnTrain.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            @Override
            public void onTrainingChange(CRPTrainingInfo info) {
                connTrain.setTrainingInfo(info);
                String jsonStr = GsonUtils.get().toJson(connTrain, ConnTrain.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }
        });
    }
}
