package com.moyoung.moyoung_ble_plugin.conn;

import android.util.Log;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.bean.CRPCustomizeWatchFaceInfo;
import com.crrepa.ble.conn.listener.CRPFileTransListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnLazyEveChlHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.conn.model.WatchFaceFlutterBean;
import com.moyoung.moyoung_ble_plugin.conn.model.WatchFaceStoreBean;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.MethodCall;

class ConnWFFileTransLazyEveChlHandler extends BaseConnLazyEveChlHandler {
    private final static String TAG = ConnWFFileTransLazyEveChlHandler.class.getSimpleName();

    @Override
    public void setLazyConnListener(CRPBleConnection connection, MethodCall call) {
        Map<String, Object> mapStr = new HashMap<>();
        Log.d(TAG, "ConnWFFileTransLazyEveChlHandler: +监听");
        String jsonStr = call.argument("watchFaceFlutterBean");
        Integer timeout = call.argument("timeout");
        timeout = timeout == null ? 30 : timeout;
        WatchFaceFlutterBean watchFaceFlutterBean = GsonUtils.get().fromJson(jsonStr, WatchFaceFlutterBean.class);
        File file = new File(watchFaceFlutterBean.getFile());

        CRPCustomizeWatchFaceInfo customizeWatchFaceInfo = new CRPCustomizeWatchFaceInfo(watchFaceFlutterBean.getIndex(), file);

        connection.sendWatchFace(customizeWatchFaceInfo, new CRPFileTransListener() {
            @Override
            public void onTransProgressStarting() {
                mapStr.put("isError", false);
                mapStr.put("progress", 1);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }

            @Override
            public void onTransProgressChanged(int progress) {
                mapStr.put("isError", false);
                mapStr.put("progress", progress);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }

            @Override
            public void onTransCompleted() {
                mapStr.put("isError", false);
                mapStr.put("progress", 100);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }

            @Override
            public void onError(int i) {
                mapStr.put("isError", true);
                mapStr.put("progress", 0);
                activity.runOnUiThread(() -> eventSink.success(mapStr));
            }
        }, timeout);
    }
}

