import 'dart:async';

import 'package:flutter/material.dart';
import 'package:logger/logger.dart';

import 'package:moyoung_ble_plugin_example/lbz.dart';
import 'package:moyoung_ble_plugin_example/system.dart';
import 'package:moyoung_ble_plugin_example/xulei.dart';
import 'package:moyoung_ble_plugin_example/yusixia.dart';

import 'package:moyoung_ble_plugin/moyang_ble.dart';

class NewRoute extends StatefulWidget {
  BleScanEvent device;

  NewRoute({
    Key? key,
    required this.device,
  }) : super(key: key);

  @override
  State<StatefulWidget> createState() {
    return _NewRoute(device);
  }
}

class _NewRoute extends State<NewRoute> {
  late BleScanEvent device;

  final _streamSubscriptions = <StreamSubscription<dynamic>>[];
  // final MoyoungBlePlugin _blePlugin = MoyoungBlePlugin();
  final MoYangBle _blePlugin = MoYangBle();


  String _isConnetced = "未连接";
  int _connetionState = -1;
  ConnStepChangeBean _connStepChange =
  ConnStepChangeBean(stepInfo: EventConnStepChange(steps: -1, distance: -1, calories: -1, time: -1),past:-1,
          pastStepInfo:EventConnStepChange(steps: -1, distance: -1, calories: -1, time: -1));
  String _newFirmwareInfo = "未获取";
  bool isConn = false;

  //余诗霞：start
  Logger logger = Logger();

  //余诗霞：end

  _NewRoute(this.device);

  @override
  void initState() {
    super.initState();
    subscriptStream();
  }

  void subscriptStream() {
    _streamSubscriptions.add(
      _blePlugin.connStateEveStm.listen(
        (int event) {
          setState(() {
            _connetionState = event;
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.connStepChangeEveStm.listen(
        (ConnStepChangeBean event) {
          setState(() {
            _connStepChange = event;
          });
        },
      ),
    );
    //余诗霞：start
    _streamSubscriptions.add(
      _blePlugin.connHeartRateEveStm.listen(
        (event) {
          setState(() {
            // logger.d('connHeartRateEveStm===' + event.measuring.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.connBloodPressureEveStm.listen(
        (event) {
          setState(() {
            // logger.d('connBloodPressureEveStm===' + event.bloodPressureChange.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.connBloodOxygenEveStm.listen(
        (event) {
          setState(() {
            // logger.d('connBloodOxygenEveStm===' + event.bloodOxygen.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.connCameraEveStm.listen(
        (event) {
          setState(() {
            logger.d('connCameraEveStm');
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.connPhoneEveStm.listen(
        (event) {
          setState(() {
            logger.d('connPhoneEveStm===' + event.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.connDeviceRssiEveStm.listen(
        (event) {
          setState(() {
            logger.d('connDeviceRssiEveStm===' + event.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.connLazyFileTransEveStm.listen(
        (event) {
          setState(() {
            logger.d('connLazyFileTransEveStm===' + event.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.connLazyWFFileTransEveStm.listen(
        (event) {
          setState(() {
            logger.d('connLazyWFFileTransEveStm===' + event.toString());
          });
        },
      ),
    );
    _streamSubscriptions.add(
      _blePlugin.connLazyEgcEveStm.listen(
        (event) {
          setState(() {
            logger.d('connLazyEgcEveStm===' + event.ints.toString());
          });
        },
      ),
    );
    //以下是李宝忠的监听
    _streamSubscriptions.add(
      _blePlugin.connLazyContactAvatarEveStm.listen(
        (event) {
          setState(() {
            logger.d('connLazyContactAvatarEveStm===' + event.toString());
          });
        },
      ),
    );
    //余诗霞：end

    _streamSubscriptions.add(
      _blePlugin.connTainStateEveStm.listen(
        (event) {
          setState(() {
            logger.d("connTainStateEveStm======" + event.toString());
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.connTempChangeEveStm.listen(
        (event) {
          setState(() {
            logger.d("connTempChangeEveStm======" + event.toString());
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.connContactEveStm.listen(
        (event) {
          setState(() {
            logger.d("connContactEveStm======" + event.toString());
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.connBatterySavingEveStm.listen(
        (event) {
          setState(() {
            logger.d("connBatterySavingEveStm======" + event.toString());
          });
        },
      ),
    );

    _streamSubscriptions.add(
      _blePlugin.connTrainingEveStm.listen(
        (event) {
          setState(() {
            logger.d("connTrainingEveStm======" + event.toString());
          });
        },
      ),
    );
  }

  @override
  void dispose() {
    super.dispose();
    for (final subscription in _streamSubscriptions) {
      subscription.cancel();
    }
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: ListView(
            children: <Widget>[
              Text(device.name + ',' + device.address),

              Text("StepChange=" + _connStepChange.stepInfo.steps.toString()),

              Text('connetionState= $_connetionState'),
              ElevatedButton(child: Text(_isConnetced), onPressed: isConnected),
              ElevatedButton(
                  child: const Text("connect"),
                  onPressed: () {
                    _blePlugin.connect(device.address);
                    isConn = true;
                  }),
              ElevatedButton(
                  child: Text('disconnect():' + _isConnetced),
                  onPressed: disconnection),
              ElevatedButton(
                  child: const Text('syncTime()'),
                  onPressed: () => _blePlugin.syncTime),
              ElevatedButton(
                  child: const Text('sendTimeSystem(TIME_SYSTEM_12)'),
                  onPressed: () => _blePlugin
                      .sendTimeSystem(CRPTimeSystemType.TIME_SYSTEM_12)),
              ElevatedButton(
                  child: const Text('sendTimeSystem(TIME_SYSTEM_24)'),
                  onPressed: () => _blePlugin
                      .sendTimeSystem(CRPTimeSystemType.TIME_SYSTEM_24)),
              ElevatedButton(
                  child: const Text('queryTimeSystem()'),
                  onPressed: () => _blePlugin.queryTimeSystem),
              ElevatedButton(
                  child: Text(_newFirmwareInfo),
                  onPressed: checkFirmwareVersion),
              ElevatedButton(
                  child: const Text('queryDeviceBattery()'),
                  onPressed: () => _blePlugin.queryDeviceBattery),
              ElevatedButton(
                  child: const Text('subscribeDeviceBattery()'),
                  onPressed: () => _blePlugin.subscribeDeviceBattery),
              ElevatedButton(
                  child: const Text('sendUserInfo()-MALE'),
                  onPressed: () => _blePlugin.sendUserInfo(CrpUserInfo(
                      weight: 50,
                      height: 180,
                      gender: CrpUserInfo.MALE,
                      age: 30))),
              ElevatedButton(
                  child: const Text('sendUserInfo()-FEMALE'),
                  onPressed: () => _blePlugin.sendUserInfo(CrpUserInfo(
                      weight: 50,
                      height: 170,
                      gender: CrpUserInfo.FEMALE,
                      age: 31))),
              ElevatedButton(
                  child: const Text('sendStepLength(5)'),
                  onPressed: () => _blePlugin.sendStepLength(5)),
              ElevatedButton(
                  child: const Text('sendTodayWeather()'),
                  onPressed: () => _blePlugin.sendTodayWeather(
                      CrpTodayWeatherInfo(
                          city: "111",
                          lunar: "111",
                          festival: "111",
                          pm25: 111,
                          temp: 111,
                          weatherId: 111))),
              ElevatedButton(
                  child: const Text('sendFutureWeather()'),
                  onPressed: () => _blePlugin.sendTodayWeather(
                      CrpTodayWeatherInfo(
                          city: "111",
                          lunar: "111",
                          festival: "111",
                          pm25: 111,
                          temp: 111,
                          weatherId: 111))),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return System(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("系统测试")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return Xulei(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("许蕾页面")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return Yusixia(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("余诗霞页面")),
              ElevatedButton(
                  onPressed: () {
                    if(isConn) {
                      Navigator.push(context,
                          MaterialPageRoute(builder: (context) {
                            return Lbz(
                              blePlugin: _blePlugin,
                            );
                          }));
                    }
                  },
                  child: const Text("李宝忠页面"))
              // libaozhong: end
            ],
          ),
        ),
      ),
    );
  }
  Future<void> isConnected() async {
    bool isConnected = await _blePlugin.isConnected(device.address);
    if (!mounted) return;
    setState(() {
      _isConnetced = isConnected ? "Connetced" : "Disconnected";
    });
  }

  Future<void> disconnection() async {
    bool disconnected = await _blePlugin.disconnect;
    if (!mounted) return;
    setState(() {
      _isConnetced = disconnected ? "Disconnected" : "Connetced";
    });
  }

  Future<void> checkFirmwareVersion() async {
    FirmwareVersionInfo versionInfo = await _blePlugin.checkFirmwareVersion;
    if (!mounted) return;
    setState(() {
      isConn = false;
      _newFirmwareInfo = firmwareVersionInfoToJson(versionInfo);
    });
  }
}
