import 'dart:typed_data';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

import 'package:moyoung_ble_plugin/moyang_ble.dart';

class Yusixia extends StatefulWidget {
  MoYangBle blePlugin;

  Yusixia({
    Key? key,
    required this.blePlugin,
  }) : super(key: key);

  @override
  State<Yusixia> createState() {
    return _YusixiaPage(blePlugin);
  }
}

class _YusixiaPage extends State<Yusixia> {
  final MoYangBle _blePlugin;

  _YusixiaPage(this._blePlugin);
  CrpWatchFaceLayoutInfo? _crpWatchFaceLayoutInfo = null;
  String _firmwareVersion = "未获取";
  CrpSupportWatchFaceInfo? _watchFaceSupportList = null;
  @override
  Widget build(BuildContext context) {

    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text("余思霞"),
        ),
        body: Center(
          child: ListView(
            children: <Widget>[
              //余诗霞:start
              ElevatedButton(
                  child: const Text('queryMetricSystem()'),
                  onPressed: () => _blePlugin.queryMetricSystem),
              ElevatedButton(
                  child: const Text('sendMetricSystem(METRIC_SYSTEM)'),
                  onPressed: () => _blePlugin
                      .sendMetricSystem(CRPMetricSystemType.METRIC_SYSTEM)),
              ElevatedButton(
                  child: const Text('sendMetricSystem(IMPERIAL_SYSTEM)'),
                  onPressed: () => _blePlugin
                      .sendMetricSystem(CRPMetricSystemType.IMPERIAL_SYSTEM)),
              ElevatedButton(
                  child: const Text('sendQuickView(true)'),
                  onPressed: () => _blePlugin.sendQuickView(true)),
              ElevatedButton(
                  child: const Text('sendQuickView(false)'),
                  onPressed: () => _blePlugin.sendQuickView(false)),
              ElevatedButton(
                  child: const Text('queryQuickView()'),
                  onPressed: () => _blePlugin.queryQuickView),
              ElevatedButton(
                  child: const Text(
                      'sendQuickViewTime(CrpPeriodTimeInfo(0,0,0,0)'),
                  onPressed: () => _blePlugin.sendQuickViewTime(
                      CrpPeriodTimeInfo(
                          endHour: 0,
                          endMinute: 0,
                          startHour: 0,
                          startMinute: 0))),
              ElevatedButton(
                  child: const Text('queryQuickViewTime()'),
                  onPressed: () => _blePlugin.queryQuickViewTime),
              ElevatedButton(
                  child: const Text('sendGoalSteps(5000)'),
                  onPressed: () => _blePlugin.sendGoalSteps(5000)),
              ElevatedButton(
                  child: const Text('queryGoalStep()'),
                  onPressed: () => _blePlugin.queryGoalStep),
              const Text("表盘"),
              ElevatedButton(
                  child: const Text('sendDisplayWatchFace(FIRST_WATCH_FACE)'),
                  onPressed: () => _blePlugin
                      .sendDisplayWatchFace(CRPWatchFaceType.FIRST_WATCH_FACE)),
              ElevatedButton(
                  child: const Text('sendDisplayWatchFace(SECOND_WATCH_FACE)'),
                  onPressed: () => _blePlugin
                      .sendDisplayWatchFace(CRPWatchFaceType.SECOND_WATCH_FACE)),
              ElevatedButton(
                  child: const Text('sendDisplayWatchFace(THIRD_WATCH_FACE)'),
                  onPressed: () => _blePlugin
                      .sendDisplayWatchFace(CRPWatchFaceType.THIRD_WATCH_FACE)),
              ElevatedButton(
                  child: const Text('sendDisplayWatchFace(NEW_CUSTOMIZE_WATCH_FACE)'),
                  onPressed: () => _blePlugin
                      .sendDisplayWatchFace(CRPWatchFaceType.NEW_CUSTOMIZE_WATCH_FACE)),
              ElevatedButton(
                  child: const Text('queryDisplayWatchFace()'),
                  onPressed: () => _blePlugin.queryDisplayWatchFace),
              ElevatedButton(
                  child: const Text('queryWatchFaceLayout()'),
                  onPressed: () async => _crpWatchFaceLayoutInfo = await _blePlugin.queryWatchFaceLayout),
              ElevatedButton(
                  child: const Text(
                      'sendWatchFaceLayout(CrpWatchFaceLayoutInfo(2)'),
                  onPressed: () => {
                    if(_crpWatchFaceLayoutInfo != null) {
                      _blePlugin.sendWatchFaceLayout(_crpWatchFaceLayoutInfo!)}
                  }),
              ElevatedButton(
                  child: const Text('sendWatchFaceBackground()'),
                  onPressed: () => sendWatchFaceBackground()),
              ElevatedButton(
                  child: const Text('querySupportWatchFace()'),
                  onPressed: () async => _watchFaceSupportList = await _blePlugin.querySupportWatchFace),
              ElevatedButton(
                  child: Text(_firmwareVersion),
                  onPressed: queryFrimwareVersion),
              ElevatedButton(
                  child: const Text('queryWatchFaceStore()'),
                  onPressed: () => {
                    if(_firmwareVersion != "未获取" && _watchFaceSupportList != null)
                    _blePlugin.queryWatchFaceStore(
                      WatchFaceStoreBean(
                          watchFaceSupportList: _watchFaceSupportList!.supportWatchFaceList,
                          firmwareVersion: _firmwareVersion,
                          pageCount: 9,
                          pageIndex: 1))}),
              ElevatedButton(
                  child: const Text('queryWatchFaceOfID()'),
                  onPressed: () => _blePlugin.queryWatchFaceOfID(3994)),
              ElevatedButton(
                  child: const Text('sendWatchFace()'),
                  onPressed: () => _blePlugin.sendWatchFace(CrpCustomizeWatchFaceInfo(
                    index: 1,
                    file: "/06b5a7790cb5034ae18233bb29ec2210.bin",
                  ),30)),
              ElevatedButton(
                  child: const Text('sendAlarmClock()'),
                  onPressed: () => _blePlugin.sendAlarmClock(CrpAlarmClockInfo(
                      enable: true,
                      hour: 0,
                      id: CrpAlarmClockInfo.FIRST_CLOCK,
                      minute: 0,
                      repeatMode: CrpAlarmClockInfo.EVERYDAY))),
              ElevatedButton(
                  child: const Text('queryAllAlarmClock()'),
                  onPressed: () => _blePlugin.queryAllAlarmClock),
              //2.16-2.20许蕾完成
              const Text("心率"),
              ElevatedButton(
                  child: const Text('queryLastDynamicRate()'),
                  onPressed: () => _blePlugin.queryLastDynamicRate),
              ElevatedButton(
                  child: const Text('enableTimingMeasureHeartRate(10)'),
                  onPressed: () => _blePlugin.enableTimingMeasureHeartRate(3)),
              ElevatedButton(
                  child: const Text('disableTimingMeasureHeartRate()'),
                  onPressed: () => _blePlugin.disableTimingMeasureHeartRate),
              ElevatedButton(
                  child: const Text('queryTimingMeasureHeartRate()'),
                  onPressed: () => _blePlugin.queryTimingMeasureHeartRate),
              ElevatedButton(
                  child: const Text(
                      'queryTodayHeartRate(TIMING_MEASURE_HEART_RATE)'),
                  onPressed: () => _blePlugin.queryTodayHeartRate(
                      CRPHeartRateType.TIMING_MEASURE_HEART_RATE)),
              ElevatedButton(
                  child: const Text('queryTodayHeartRate(ALL_DAY_HEART_RATE)'),
                  onPressed: () => _blePlugin.queryTodayHeartRate(
                      CRPHeartRateType.ALL_DAY_HEART_RATE)),
              ElevatedButton(
                  child: const Text('queryPastHeartRate'),
                  onPressed: () => _blePlugin.queryPastHeartRate),
              ElevatedButton(
                  child: const Text('queryMovementHeartRate'),
                  onPressed: () => _blePlugin.queryMovementHeartRate),
              ElevatedButton(
                  child: const Text('startMeasureOnceHeartRate'),
                  onPressed: () => _blePlugin.startMeasureOnceHeartRate),
              ElevatedButton(
                  child: const Text('stopMeasureOnceHeartRate'),
                  onPressed: () => _blePlugin.stopMeasureOnceHeartRate),
              ElevatedButton(
                  child: const Text('queryHistoryHeartRate'),
                  onPressed: () => _blePlugin.queryHistoryHeartRate),
              //心率到这里结束
              const Text("血压"),
              ElevatedButton(
                  child: const Text('startMeasureBloodPressure'),
                  onPressed: () => _blePlugin.startMeasureBloodPressure),
              ElevatedButton(
                  child: const Text('stopMeasureBloodPressure'),
                  onPressed: () => _blePlugin.stopMeasureBloodPressure),
              ElevatedButton(
                  child: const Text('enableContinueBloodPressure'),
                  onPressed: () => _blePlugin.enableContinueBloodPressure),
              ElevatedButton(
                  child: const Text('disableContinueBloodPressure'),
                  onPressed: () => _blePlugin.disableContinueBloodPressure),
              ElevatedButton(
                  child: const Text('queryContinueBloodPressureState'),
                  onPressed: () => _blePlugin.queryContinueBloodPressureState),
              ElevatedButton(
                  child: const Text('queryLast24HourBloodPressure'),
                  onPressed: () => _blePlugin.queryLast24HourBloodPressure),
              ElevatedButton(
                  child: const Text('queryHistoryBloodPressure'),
                  onPressed: () => _blePlugin.queryHistoryBloodPressure),
              //血氧
              const Text("血氧"),
              ElevatedButton(
                  child: const Text('startMeasureBloodOxygen'),
                  onPressed: () => _blePlugin.startMeasureBloodOxygen),
              ElevatedButton(
                  child: const Text('stopMeasureBloodOxygen'),
                  onPressed: () => _blePlugin.stopMeasureBloodOxygen),
              ElevatedButton(
                  child: const Text('enableTimingMeasureBloodOxygen(10)'),
                  onPressed: () =>
                      _blePlugin.enableTimingMeasureBloodOxygen(10)),
              ElevatedButton(
                  child: const Text('disableTimingMeasureBloodOxygen'),
                  onPressed: () => _blePlugin.disableTimingMeasureBloodOxygen),
              ElevatedButton(
                  child: const Text('queryTimingBloodOxygenMeasureState'),
                  onPressed: () =>
                      _blePlugin.queryTimingBloodOxygenMeasureState),
              ElevatedButton(
                  child: const Text('queryTimingBloodOxygen(CRPBloodOxygenTimeType)'),
                  onPressed: () => _blePlugin.queryTimingBloodOxygen(CRPBloodOxygenTimeType.TODAY)),
              ElevatedButton(
                  child: const Text('enableContinueBloodOxygen'),
                  onPressed: () => _blePlugin.enableContinueBloodOxygen),
              ElevatedButton(
                  child: const Text('disableContinueBloodOxygen'),
                  onPressed: () => _blePlugin.disableContinueBloodOxygen),
              ElevatedButton(
                  child: const Text('queryContinueBloodOxygenState'),
                  onPressed: () => _blePlugin.queryContinueBloodOxygenState),
              ElevatedButton(
                  child: const Text('queryLast24HourBloodOxygen'),
                  onPressed: () => _blePlugin.queryLast24HourBloodOxygen),
              ElevatedButton(
                  child: const Text('queryHistoryBloodOxygen'),
                  onPressed: () => _blePlugin.queryHistoryBloodOxygen),
              //拍照
              ElevatedButton(
                  child: const Text('enterCameraView'),
                  onPressed: () => _blePlugin.enterCameraView),
              ElevatedButton(
                  child: const Text('exitCameraView'),
                  onPressed: () => _blePlugin.exitCameraView),
              //rssi
              ElevatedButton(
                  child: const Text('readDeviceRssi'),
                  onPressed: () => _blePlugin.readDeviceRssi),
              //egc
              const Text("EGC"),
              ElevatedButton(
                  child: const Text('setECGChangeListener()'),
                  onPressed: () => _blePlugin.setECGChangeListener(CRPEcgMeasureType.TI)),
              ElevatedButton(
                  child: const Text('startECGMeasure'),
                  onPressed: () => _blePlugin.startECGMeasure),
              ElevatedButton(
                  child: const Text('stopECGMeasure'),
                  onPressed: () => _blePlugin.stopECGMeasure),
              ElevatedButton(
                  child: const Text('isNewECGMeasurementVersion'),
                  onPressed: () => _blePlugin.isNewECGMeasurementVersion),
              ElevatedButton(
                  child: const Text('queryLastMeasureECGData'),
                  onPressed: () => _blePlugin.queryLastMeasureECGData),
              ElevatedButton(
                  child: const Text('sendECGHeartRate'),
                  onPressed: () => _blePlugin.sendECGHeartRate(78)),
              //余诗霞:end
            ],
          ),
        ),
      ),
    );
  }

  sendWatchFaceBackground() async {
    String filePath = "assets/images/logo.png";
    ByteData bytes = await rootBundle.load(filePath);
    Uint8List logoUint8List = bytes.buffer.asUint8List();
      _blePlugin.sendWatchFaceBackground(CrpWatchFaceBackgroundInfo(
          bitmap: logoUint8List,
          thumBitmap: logoUint8List,
          type:"LZO"
      ));
  }

  Future<void> queryFrimwareVersion() async {
    String firmwareVersion = await _blePlugin.queryFirmwareVersion;
    if (!mounted) return;
    setState(() {
      _firmwareVersion = firmwareVersion;
    });
  }
}
