import 'dart:convert';

import 'dart:typed_data';

EventConnStepChange eventConnStepChangeFromJson(String str) => EventConnStepChange.fromJson(json.decode(str));
String eventConnStepChangeToJson(EventConnStepChange data) => json.encode(data.toJson());
class EventConnStepChange {
  EventConnStepChange({
    required this.calories,
    required this.distance,
    required this.steps,
    required this.time,
  });

  int calories;
  int distance;
  int steps;
  int time;

  factory EventConnStepChange.fromJson(Map<String, dynamic> json) => EventConnStepChange(
    calories: json["calories"],
    distance: json["distance"],
    steps: json["steps"],
    time: json["time"],
  );

  Map<String, dynamic> toJson() => {
    "calories": calories,
    "distance": distance,
    "steps": steps,
    "time": time,
  };
}

BleScanEvent bleScanEventFromJson(String str) => BleScanEvent.fromJson(json.decode(str));
String bleScanEventToJson(BleScanEvent data) => json.encode(data.toJson());
class BleScanEvent {
  BleScanEvent({
    required this.address,
    required this.mRssi,
    required this.mScanRecord,
    required this.name,
  });

  String address;
  int mRssi;
  List<int> mScanRecord;
  String name;

  factory BleScanEvent.fromJson(Map<String, dynamic> json) => BleScanEvent(
    address: json["address"],
    mRssi: json["mRssi"],
    mScanRecord: List<int>.from(json["mScanRecord"].map((x) => x)),
    name: json["name"],
  );

  Map<String, dynamic> toJson() => {
    "address": address,
    "mRssi": mRssi,
    "mScanRecord": List<dynamic>.from(mScanRecord.map((x) => x)),
    "name": name,
  };
}

FirmwareVersionInfo firmwareVersionInfoFromJson(String str) => FirmwareVersionInfo.fromJson(json.decode(str));
String firmwareVersionInfoToJson(FirmwareVersionInfo data) => json.encode(data.toJson());
class FirmwareVersionInfo {
  FirmwareVersionInfo({
    required this.changeNotes,
    required this.changeNotesEn,
    required this.mcu,
    required this.tpUpgrade,
    required this.type,
    required this.version,
  });

  String changeNotes;
  String changeNotesEn;
  int mcu;
  bool tpUpgrade;
  int type;
  String version;

  factory FirmwareVersionInfo.fromJson(Map<String, dynamic> json) => FirmwareVersionInfo(
    changeNotes: json["changeNotes"],
    changeNotesEn: json["changeNotesEn"],
    mcu: json["mcu"],
    tpUpgrade: json["tpUpgrade"],
    type: json["type"],
    version: json["version"],
  );

  Map<String, dynamic> toJson() => {
    "changeNotes": changeNotes,
    "changeNotesEn": changeNotesEn,
    "mcu": mcu,
    "tpUpgrade": tpUpgrade,
    "type": type,
    "version": version,
  };
}

CrpUserInfo crpUserInfoFromJson(String str) =>
    CrpUserInfo.fromJson(json.decode(str));
String crpUserInfoToJson(CrpUserInfo data) => json.encode(data.toJson());
class CrpUserInfo {
  static const int MALE = 0;
  static const int FEMALE = 1;

  CrpUserInfo({
    required this.weight,
    required this.height,
    required this.gender,
    required this.age,
  });

  int weight;
  int height;
  int gender;
  int age;

  factory CrpUserInfo.fromJson(Map<String, dynamic> json) => CrpUserInfo(
        weight: json["weight"],
        height: json["height"],
        gender: json["gender"],
        age: json["age"],
      );

  Map<String, dynamic> toJson() => {
        "weight": weight,
        "height": height,
        "gender": gender,
        "age": age,
      };
}

CrpTodayWeatherInfo crpTodayWeatherInfoFromJson(String str) =>
    CrpTodayWeatherInfo.fromJson(json.decode(str));

String crpTodayWeatherInfoToJson(CrpTodayWeatherInfo data) =>
    json.encode(data.toJson());

class CrpTodayWeatherInfo {
  CrpTodayWeatherInfo({
    required this.city,
    required this.lunar,
    required this.festival,
    required this.pm25,
    required this.temp,
    required this.weatherId,
  });

  String city;
  String lunar;
  String festival;
  int pm25;
  int temp;
  int weatherId;

  factory CrpTodayWeatherInfo.fromJson(Map<String, dynamic> json) =>
      CrpTodayWeatherInfo(
        city: json["city"],
        lunar: json["lunar"],
        festival: json["festival"],
        pm25: json["pm25"],
        temp: json["temp"],
        weatherId: json["weatherId"],
      );

  Map<String, dynamic> toJson() => {
        "city": city,
        "lunar": lunar,
        "festival": festival,
        "pm25": pm25,
        "temp": temp,
        "weatherId": weatherId,
      };
}

//yushixia:start
CrpPeriodTimeInfo crpPeriodTimeInfoFromJson(String str) =>
    CrpPeriodTimeInfo.fromJson(json.decode(str));

String crpPeriodTimeInfoToJson(CrpPeriodTimeInfo data) =>
    json.encode(data.toJson());

class CrpPeriodTimeInfo {
  CrpPeriodTimeInfo({
    required this.endHour,
    required this.endMinute,
    required this.startHour,
    required this.startMinute,
  });

  int endHour;
  int endMinute;
  int startHour;
  int startMinute;

  factory CrpPeriodTimeInfo.fromJson(Map<String, dynamic> json) =>
      CrpPeriodTimeInfo(
        endHour: json["endHour"],
        endMinute: json["endMinute"],
        startHour: json["startHour"],
        startMinute: json["startMinute"],
      );

  Map<String, dynamic> toJson() => {
        "endHour": endHour,
        "endMinute": endMinute,
        "startHour": startHour,
        "startMinute": startMinute,
      };
}

CrpWatchFaceLayoutInfo crpWatchFaceLayoutInfoFromJson(String str) =>
    CrpWatchFaceLayoutInfo.fromJson(json.decode(str));

String crpWatchFaceLayoutInfoToJson(CrpWatchFaceLayoutInfo data) =>
    json.encode(data.toJson());

class CrpWatchFaceLayoutInfo {
  CrpWatchFaceLayoutInfo({
    required this.backgroundPictureMd5,
    required this.compressionType,
    required this.height,
    required this.textColor,
    required this.thumHeight,
    required this.thumWidth,
    required this.timeBottomContent,
    required this.timePosition,
    required this.timeTopContent,
    required this.width,
  });

  String backgroundPictureMd5;
  String compressionType;
  int height;
  int textColor;
  int thumHeight;
  int thumWidth;
  int timeBottomContent;
  int timePosition;
  int timeTopContent;
  int width;

  factory CrpWatchFaceLayoutInfo.fromJson(Map<String, dynamic> json) =>
      CrpWatchFaceLayoutInfo(
        backgroundPictureMd5: json["backgroundPictureMd5"],
        compressionType: json["compressionType"],
        height: json["height"],
        textColor: json["textColor"],
        thumHeight: json["thumHeight"],
        thumWidth: json["thumWidth"],
        timeBottomContent: json["timeBottomContent"],
        timePosition: json["timePosition"],
        timeTopContent: json["timeTopContent"],
        width: json["width"],
      );

  Map<String, dynamic> toJson() => {
        "backgroundPictureMd5": backgroundPictureMd5,
        "compressionType": compressionType,
        "height": height,
        "textColor": textColor,
        "thumHeight": thumHeight,
        "thumWidth": thumWidth,
        "timeBottomContent": timeBottomContent,
        "timePosition": timePosition,
        "timeTopContent": timeTopContent,
        "width": width,
      };
}

CrpAlarmClockInfo crpAlarmClockInfoFromJson(String str) =>
    CrpAlarmClockInfo.fromJson(json.decode(str));

String crpAlarmClockInfoToJson(CrpAlarmClockInfo data) =>
    json.encode(data.toJson());

class CrpAlarmClockInfo {
  CrpAlarmClockInfo({
    required this.enable,
    required this.hour,
    required this.id,
    required this.minute,
    required this.repeatMode,
  });

  bool enable;
  int hour;
  int id;
  int minute;
  int repeatMode;

  static const int FIRST_CLOCK = 0;
  static const int SECOND_CLOCK = 1;
  static const int THIRD_CLOCK = 2;

  static const int SINGLE = 0;
  static const int SUNDAY = 1;
  static const int MONDAY = 2;
  static const int TUESDAY = 4;
  static const int WEDNESDAY = 8;
  static const int THURSDAY = 16;
  static const int FRIDAY = 32;
  static const int SATURDAY = 64;
  static const int EVERYDAY = 127;

  factory CrpAlarmClockInfo.fromJson(Map<String, dynamic> json) =>
      CrpAlarmClockInfo(
        enable: json["enable"],
        hour: json["hour"],
        id: json["id"],
        minute: json["minute"],
        repeatMode: json["repeatMode"],
      );

  Map<String, dynamic> toJson() => {
        "enable": enable,
        "hour": hour,
        "id": id,
        "minute": minute,
        "repeatMode": repeatMode,
      };
}
CrpSupportWatchFaceInfo crpSupportWatchFaceInfoFromJson(String str) => CrpSupportWatchFaceInfo.fromJson(json.decode(str));

String crpSupportWatchFaceInfoToJson(CrpSupportWatchFaceInfo data) => json.encode(data.toJson());

class CrpSupportWatchFaceInfo {
  CrpSupportWatchFaceInfo({
    required this.displayWatchFace,
    required this.supportWatchFaceList,
  });

  int displayWatchFace;
  List<int> supportWatchFaceList;

  factory CrpSupportWatchFaceInfo.fromJson(Map<String, dynamic> json) => CrpSupportWatchFaceInfo(
    displayWatchFace: json["displayWatchFace"],
    supportWatchFaceList: List<int>.from(json["supportWatchFaceList"].map((x) => x)),
  );

  Map<String, dynamic> toJson() => {
    "displayWatchFace": displayWatchFace,
    "supportWatchFaceList": List<dynamic>.from(supportWatchFaceList.map((x) => x)),
  };
}

WatchFaceStoreBean watchFaceStoreBeanFromJson(String str) => WatchFaceStoreBean.fromJson(json.decode(str));

String watchFaceStoreBeanToJson(WatchFaceStoreBean data) => json.encode(data.toJson());

class WatchFaceStoreBean {
  WatchFaceStoreBean({
    required this.watchFaceSupportList,
    required this.firmwareVersion,
    required this.pageCount,
    required this.pageIndex,
  });

  List<int> watchFaceSupportList;
  String firmwareVersion;
  int pageCount;
  int pageIndex;

  factory WatchFaceStoreBean.fromJson(Map<String, dynamic> json) => WatchFaceStoreBean(
    watchFaceSupportList: List<int>.from(json["list"].map((x) => x)),
    firmwareVersion: json["firmwareVersion"],
    pageCount: json["pageCount"],
    pageIndex: json["pageIndex"],
  );

  Map<String, dynamic> toJson() => {
    "watchFaceSupportList": List<dynamic>.from(watchFaceSupportList.map((x) => x)),
    "firmwareVersion": firmwareVersion,
    "pageCount": pageCount,
    "pageIndex": pageIndex,
  };
}
WatchFaceBean watchFaceBeanFromJson(String str) => WatchFaceBean.fromJson(json.decode(str));

String watchFaceBeanToJson(WatchFaceBean data) => json.encode(data.toJson());

class WatchFaceBean {
  WatchFaceBean({
    required this.id,
    required this.preview,
    required this.file,
  });

  int id;
  String preview;
  String file;

  factory WatchFaceBean.fromJson(Map<String, dynamic> json) => WatchFaceBean(
    id: json["id"],
    preview: json["preview"],
    file: json["file"],
  );

  Map<String, dynamic> toJson() => {
    "id": id,
    "preview": preview,
    "file": file,
  };
}

CrpWatchFaceBackgroundInfo crpWatchFaceBackgroundInfoFromJson(String str) => CrpWatchFaceBackgroundInfo.fromJson(json.decode(str));

String crpWatchFaceBackgroundInfoToJson(CrpWatchFaceBackgroundInfo data) => json.encode(data.toJson());

class CrpWatchFaceBackgroundInfo {
  CrpWatchFaceBackgroundInfo({
    required this.bitmap,
    required this.thumBitmap,
    required this.type,
  });

  Uint8List bitmap;
  Uint8List thumBitmap;
  String type;
  static const int DEFAULT_TIMEOUT = 30;
  static const int timeout = 30;

  factory CrpWatchFaceBackgroundInfo.fromJson(Map<String, dynamic> json) => CrpWatchFaceBackgroundInfo(
    bitmap: json["bitmap"],
    thumBitmap: json["thumBitmap"],
    type: json["type"],
  );

  Map<String, dynamic> toJson() => {
    "bitmap": bitmap,
    "thumBitmap": thumBitmap,
    "type": type,
  };
}

CrpCustomizeWatchFaceInfo crpCustomizeWatchFaceInfoFromJson(String str) => CrpCustomizeWatchFaceInfo.fromJson(json.decode(str));

String crpCustomizeWatchFaceInfoToJson(CrpCustomizeWatchFaceInfo data) => json.encode(data.toJson());

class CrpCustomizeWatchFaceInfo {
  CrpCustomizeWatchFaceInfo({
    required this.index,
    required this.file,
  });

  int index;
  String file;

  factory CrpCustomizeWatchFaceInfo.fromJson(Map<String, dynamic> json) => CrpCustomizeWatchFaceInfo(
    index: json["index"],
    file: json["file"],
  );

  Map<String, dynamic> toJson() => {
    "index": index,
    "file": file,
  };
}
//以下实体是监听的返回值实体
//步数监听返回值的实体
ConnStepChangeBean connStepChangeBeanFromJson(String str) => ConnStepChangeBean.fromJson(json.decode(str));

String connStepChangeBeanToJson(ConnStepChangeBean data) => json.encode(data.toJson());

class ConnStepChangeBean {
  ConnStepChangeBean({
    required this.stepInfo,
    required this.past,
    required this.pastStepInfo,
  });

  EventConnStepChange stepInfo;
  int past;
  EventConnStepChange pastStepInfo;

  factory ConnStepChangeBean.fromJson(Map<String, dynamic> json) => ConnStepChangeBean(
    stepInfo: EventConnStepChange.fromJson(json["stepInfo"]),
    past: json["past"],
    pastStepInfo: EventConnStepChange.fromJson(json["pastStepInfo"]),
  );

  Map<String, dynamic> toJson() => {
    "stepInfo": stepInfo.toJson(),
    "past": past,
    "pastStepInfo": pastStepInfo.toJson(),
  };
}

//心率
CrpHistoryHeartRateInfo crpHistoryHeartRateInfoFromJson(String str) => CrpHistoryHeartRateInfo.fromJson(json.decode(str));

String crpHistoryHeartRateInfoToJson(CrpHistoryHeartRateInfo data) => json.encode(data.toJson());

class CrpHistoryHeartRateInfo {
  CrpHistoryHeartRateInfo({
    required this.date,
    required this.hr,
  });

  String date;
  int hr;

  factory CrpHistoryHeartRateInfo.fromJson(Map<String, dynamic> json) => CrpHistoryHeartRateInfo(
    date: json["date"],
    hr: json["hr"],
  );

  Map<String, dynamic> toJson() => {
    "date": date,
    "hr": hr,
  };
}

CrpHeartRateInfo crpHeartRateInfoFromJson(String str) => CrpHeartRateInfo.fromJson(json.decode(str));

String crpHeartRateInfoToJson(CrpHeartRateInfo data) => json.encode(data.toJson());

class CrpHeartRateInfo {
  CrpHeartRateInfo({
    required this.startTime,
    required this.heartRateList,
    required this.timeInterval,
    required this.heartRateType,
  });

  int startTime;
  List<int> heartRateList;
  int timeInterval;
  String heartRateType;

  factory CrpHeartRateInfo.fromJson(Map<String, dynamic> json) => CrpHeartRateInfo(
    startTime: json["startTime"],
    heartRateList: List<int>.from(json["heartRateList"].map((x) => x)),
    timeInterval: json["timeInterval"],
    heartRateType: json["heartRateType"],
  );

  Map<String, dynamic> toJson() => {
    "startTime": startTime,
    "heartRateList": List<dynamic>.from(heartRateList.map((x) => x)),
    "timeInterval": timeInterval,
    "heartRateType": heartRateType,
  };
}
CrpMovementHeartRateInfo crpMovementHeartRateInfoFromJson(String str) => CrpMovementHeartRateInfo.fromJson(json.decode(str));

String crpMovementHeartRateInfoToJson(CrpMovementHeartRateInfo data) => json.encode(data.toJson());

class CrpMovementHeartRateInfo {
  CrpMovementHeartRateInfo({
    required this.type,
    required this.startTime,
    required this.endTime,
    required this.validTime,
    required this.steps,
    required this.distance,
    required this.calories,
  });

  int type;
  int startTime;
  int endTime;
  int validTime;
  int steps;
  int distance;
  int calories;

  factory CrpMovementHeartRateInfo.fromJson(Map<String, dynamic> json) => CrpMovementHeartRateInfo(
    type: json["type"],
    startTime: json["startTime"],
    endTime: json["endTime"],
    validTime: json["validTime"],
    steps: json["steps"],
    distance: json["distance"],
    calories: json["calories"],
  );

  Map<String, dynamic> toJson() => {
    "type": type,
    "startTime": startTime,
    "endTime": endTime,
    "validTime": validTime,
    "steps": steps,
    "distance": distance,
    "calories": calories,
  };
}
ConnHeartRateBean connHeartRateBeanFromJson(String str) => ConnHeartRateBean.fromJson(json.decode(str));

String connHeartRateBeanToJson(ConnHeartRateBean data) => json.encode(data.toJson());

class ConnHeartRateBean {
  ConnHeartRateBean({
    required this.measuring,
    required this.onceMeasureComplete,
    required this.historyHrList,
    required this.historyDynamicRateType,
    required this.measureComplete,
    required this.hour24MeasureResult,
    required this.movementList,
  });

  int measuring;
  int onceMeasureComplete;
  List<CrpHistoryHeartRateInfo> historyHrList;
  String historyDynamicRateType;
  CrpHeartRateInfo measureComplete;
  CrpHeartRateInfo hour24MeasureResult;
  List<CrpMovementHeartRateInfo> movementList;

  factory ConnHeartRateBean.fromJson(Map<String, dynamic> json) => ConnHeartRateBean(
    measuring: json["measuring"],
    onceMeasureComplete: json["onceMeasureComplete"],
    historyHrList: List<CrpHistoryHeartRateInfo>.from(json["historyHRList"].map((x) => CrpHistoryHeartRateInfo.fromJson(x))),
    historyDynamicRateType: json["historyDynamicRateType"],
    measureComplete: CrpHeartRateInfo.fromJson(json["measureComplete"]),
    hour24MeasureResult: CrpHeartRateInfo.fromJson(json["hour24MeasureResult"]),
    movementList: List<CrpMovementHeartRateInfo>.from(json["movementList"].map((x) => CrpMovementHeartRateInfo.fromJson(x))),
  );

  Map<String, dynamic> toJson() => {
    "measuring": measuring,
    "onceMeasureComplete": onceMeasureComplete,
    "historyHRList": List<dynamic>.from(historyHrList.map((x) => x.toJson())),
    "historyDynamicRateType": historyDynamicRateType,
    "measureComplete": measureComplete.toJson(),
    "hour24MeasureResult": hour24MeasureResult.toJson(),
    "movementList": List<dynamic>.from(movementList.map((x) => x.toJson())),
  };
}

//血压
ConnBloodPressureBean connBloodPressureBeanFromJson(String str) => ConnBloodPressureBean.fromJson(json.decode(str));

String connBloodPressureBeanToJson(ConnBloodPressureBean data) => json.encode(data.toJson());

class ConnBloodPressureBean {
  ConnBloodPressureBean({
    required this.continueState,
    required this.bloodPressureChange,
    required this.bloodPressureChange1,
    required this.historyBpList,
    required this.continueBp,
  });

  bool continueState;
  int bloodPressureChange;
  int bloodPressureChange1;
  List<CrpHistoryBloodPressureInfo> historyBpList;
  CrpBloodPressureInfo continueBp;

  factory ConnBloodPressureBean.fromJson(Map<String, dynamic> json) => ConnBloodPressureBean(
    continueState: json["continueState"],
    bloodPressureChange: json["bloodPressureChange"],
    bloodPressureChange1: json["bloodPressureChange1"],
    historyBpList: List<CrpHistoryBloodPressureInfo>.from(json["historyBPList"].map((x) => CrpHistoryBloodPressureInfo.fromJson(x))),
    continueBp: CrpBloodPressureInfo.fromJson(json["continueBP"]),
  );

  Map<String, dynamic> toJson() => {
    "continueState": continueState,
    "bloodPressureChange": bloodPressureChange,
    "bloodPressureChange1": bloodPressureChange1,
    "historyBPList": List<dynamic>.from(historyBpList.map((x) => x.toJson())),
    "continueBP": continueBp.toJson(),
  };
}
CrpHistoryBloodPressureInfo crpHistoryBloodPressureInfoFromJson(String str) => CrpHistoryBloodPressureInfo.fromJson(json.decode(str));

String crpHistoryBloodPressureInfoToJson(CrpHistoryBloodPressureInfo data) => json.encode(data.toJson());

class CrpHistoryBloodPressureInfo {
  CrpHistoryBloodPressureInfo({
    required this.date,
    required this.sbp,
    required this.dbp,
  });

  String date;
  int sbp;
  int dbp;

  factory CrpHistoryBloodPressureInfo.fromJson(Map<String, dynamic> json) => CrpHistoryBloodPressureInfo(
    date: json["date"],
    sbp: json["sbp"],
    dbp: json["dbp"],
  );

  Map<String, dynamic> toJson() => {
    "date": date,
    "sbp": sbp,
    "dbp": dbp,
  };
}
CrpBloodPressureInfo crpBloodPressureInfoFromJson(String str) => CrpBloodPressureInfo.fromJson(json.decode(str));

String crpBloodPressureInfoToJson(CrpBloodPressureInfo data) => json.encode(data.toJson());

class CrpBloodPressureInfo {
  CrpBloodPressureInfo({
    required this.startTime,
    required this.timeInterval,
  });

  int startTime;
  int timeInterval;

  factory CrpBloodPressureInfo.fromJson(Map<String, dynamic> json) => CrpBloodPressureInfo(
    startTime: json["startTime"],
    timeInterval: json["timeInterval"],
  );

  Map<String, dynamic> toJson() => {
    "startTime": startTime,
    "timeInterval": timeInterval,
  };
}

//血氧
ConnBloodOxygenBean connBloodOxygenBeanFromJson(String str) => ConnBloodOxygenBean.fromJson(json.decode(str));

String connBloodOxygenBeanToJson(ConnBloodOxygenBean data) => json.encode(data.toJson());

class ConnBloodOxygenBean {
  ConnBloodOxygenBean({
    required this.continueState,
    required this.timingMeasure,
    required this.bloodOxygen,
    required this.historyList,
    required this.continueBo,
  });

  bool continueState;
  int timingMeasure;
  int bloodOxygen;
  List<CrpHistoryBloodOxygenInfo> historyList;
  CrpBloodOxygenInfo continueBo;

  factory ConnBloodOxygenBean.fromJson(Map<String, dynamic> json) => ConnBloodOxygenBean(
    continueState: json["continueState"],
    timingMeasure: json["timingMeasure"],
    bloodOxygen: json["bloodOxygen"],
    historyList: List<CrpHistoryBloodOxygenInfo>.from(json["historyList"].map((x) => CrpHistoryBloodOxygenInfo.fromJson(x))),
    continueBo: CrpBloodOxygenInfo.fromJson(json["continueBO"]),
  );

  Map<String, dynamic> toJson() => {
    "continueState": continueState,
    "timingMeasure": timingMeasure,
    "bloodOxygen": bloodOxygen,
    "historyList": List<dynamic>.from(historyList.map((x) => x.toJson())),
    "continueBO": continueBo.toJson(),
  };
}
CrpHistoryBloodOxygenInfo crpHistoryBloodOxygenInfoFromJson(String str) => CrpHistoryBloodOxygenInfo.fromJson(json.decode(str));

String crpHistoryBloodOxygenInfoToJson(CrpHistoryBloodOxygenInfo data) => json.encode(data.toJson());

class CrpHistoryBloodOxygenInfo {
  CrpHistoryBloodOxygenInfo({
    required this.date,
    required this.bo,
  });

  String date;
  int bo;

  factory CrpHistoryBloodOxygenInfo.fromJson(Map<String, dynamic> json) => CrpHistoryBloodOxygenInfo(
    date: json["date"],
    bo: json["bo"],
  );

  Map<String, dynamic> toJson() => {
    "date": date,
    "bo": bo,
  };
}
CrpBloodOxygenInfo crpBloodOxygenInfoFromJson(String str) => CrpBloodOxygenInfo.fromJson(json.decode(str));

String crpBloodOxygenInfoToJson(CrpBloodOxygenInfo data) => json.encode(data.toJson());

class CrpBloodOxygenInfo {
  CrpBloodOxygenInfo({
    required this.startTime,
    // required this.type,
    // required this.list,
    required this.timeInterval,
  });

  int startTime;
  // String type;
  // List<int> list;
  int timeInterval;

  factory CrpBloodOxygenInfo.fromJson(Map<String, dynamic> json) => CrpBloodOxygenInfo(
    startTime: json["startTime"],
    // type: json["type"],
    // list: List<int>.from(json["list"].map((x) => x)),
    timeInterval: json["timeInterval"],
  );

  Map<String, dynamic> toJson() => {
    "startTime": startTime,
    // "type": type,
    // "list": List<dynamic>.from(list.map((x) => x)),
    "timeInterval": timeInterval,
  };
}


//egc
ConnEgcBean connEgcBeanFromJson(String str) => ConnEgcBean.fromJson(json.decode(str));

String connEgcBeanToJson(ConnEgcBean data) => json.encode(data.toJson());

class ConnEgcBean {
  ConnEgcBean({
    required this.ints,
    required this.measureComplete,
    required this.date,
    required this.isCancel,
    required this.isFail,
  });

  List<int> ints;
  int measureComplete;
  String date;
  bool isCancel;
  bool isFail;

  factory ConnEgcBean.fromJson(Map<String, dynamic> json) => ConnEgcBean(
    ints: List<int>.from(json["ints"].map((x) => x)),
    measureComplete: json["measureComplete"],
    date: json["date"],
    isCancel: json["isCancel"],
    isFail: json["isFail"],
  );

  Map<String, dynamic> toJson() => {
    "ints": List<dynamic>.from(ints.map((x) => x)),
    "measureComplete": measureComplete,
    "date": date,
    "isCancel": isCancel,
    "isFail": isFail,
  };
}

//以下实体是李宝忠的
CrpFileTrans crpFileTransFromJson(String str) =>
    CrpFileTrans.fromJson(json.decode(str));

String crpFileTransToJson(CrpFileTrans data) => json.encode(data.toJson());

class CrpFileTrans {
  CrpFileTrans({
    required this.var1,
    required this.image,
    required this.var2,
  });

  int var1;
  String image;
  int var2;

  factory CrpFileTrans.fromJson(Map<String, dynamic> json) => CrpFileTrans(
        var1: json["var1"],
        image: json["image"],
        var2: json["var2"],
      );

  Map<String, dynamic> toJson() => {
        "var1": var1,
        "image": image,
        "var2": var2,
      };
}
//yushixia:end

//xulei:start
CrpMessageInfo crpMessageInfoFromJson(String str) => CrpMessageInfo.fromJson(json.decode(str));

String crpMessageInfoToJson(CrpMessageInfo data) => json.encode(data.toJson());

class CrpMessageInfo {
  CrpMessageInfo({
    required this.message,
    required this.type,
    required this.versionCode,
    required this.isHs,
    required this.isSmallScreen,
  });

  String message;
  int type;
  int versionCode;
  bool isHs;
  bool isSmallScreen;

  factory CrpMessageInfo.fromJson(Map<String, dynamic> json) => CrpMessageInfo(
    message: json["message"],
    type: json["type"],
    versionCode: json["versionCode"],
    isHs: json["isHs"],
    isSmallScreen: json["isSmallScreen"],
  );

  Map<String, dynamic> toJson() => {
    "message": message,
    "type": type,
    "versionCode": versionCode,
    "isHs": isHs,
    "isSmallScreen": isSmallScreen,
  };
}

CrpSedentaryReminderPeriodInfo crpSedentaryReminderPeriodInfoFromJson(String str) => CrpSedentaryReminderPeriodInfo.fromJson(json.decode(str));

String crpSedentaryReminderPeriodInfoToJson(CrpSedentaryReminderPeriodInfo data) => json.encode(data.toJson());

class CrpSedentaryReminderPeriodInfo {
  CrpSedentaryReminderPeriodInfo({
    required this.endHour,
    required this.period,
    required this.startHour,
    required this.steps,
  });

  int endHour;
  int period;
  int startHour;
  int steps;

  factory CrpSedentaryReminderPeriodInfo.fromJson(Map<String, dynamic> json) => CrpSedentaryReminderPeriodInfo(
    endHour: json["endHour"],
    period: json["period"],
    startHour: json["startHour"],
    steps: json["steps"],
  );

  Map<String, dynamic> toJson() => {
    "endHour": endHour,
    "period": period,
    "startHour": startHour,
    "steps": steps,
  };
}


//xulei:end

// libaozhong: start
CrpPhysiologcalPeriodInfo crpPhysiologcalPeriodInfoFromJson(String str) => CrpPhysiologcalPeriodInfo.fromJson(json.decode(str));
String crpPhysiologcalPeriodInfoToJson(CrpPhysiologcalPeriodInfo data) => json.encode(data.toJson());
class CrpPhysiologcalPeriodInfo {
  CrpPhysiologcalPeriodInfo({
    required this.physiologcalPeriod,
    required this.menstrualPeriod,
    required this.startDate,
    required this.menstrualReminder,
    required this.ovulationReminder,
    required this.ovulationDayReminder,
    required this.ovulationEndReminder,
    required this.reminderHour,
    required this.reminderMinute,
  });

  int physiologcalPeriod;
  int menstrualPeriod;
  int startDate;
  bool menstrualReminder;
  bool ovulationReminder;
  bool ovulationDayReminder;
  bool ovulationEndReminder;
  int reminderHour;
  int reminderMinute;

  factory CrpPhysiologcalPeriodInfo.fromJson(Map<String, dynamic> json) => CrpPhysiologcalPeriodInfo(
    physiologcalPeriod: json["physiologcalPeriod"],
    menstrualPeriod: json["menstrualPeriod"],
    startDate: json["startDate"],
    menstrualReminder: json["menstrualReminder"],
    ovulationReminder: json["ovulationReminder"],
    ovulationDayReminder: json["ovulationDayReminder"],
    ovulationEndReminder: json["ovulationEndReminder"],
    reminderHour: json["reminderHour"],
    reminderMinute: json["reminderMinute"],
  );

  Map<String, dynamic> toJson() => {
    "physiologcalPeriod": physiologcalPeriod,
    "menstrualPeriod": menstrualPeriod,
    "startDate": startDate,
    "menstrualReminder": menstrualReminder,
    "ovulationReminder": ovulationReminder,
    "ovulationDayReminder": ovulationDayReminder,
    "ovulationEndReminder": ovulationEndReminder,
    "reminderHour": reminderHour,
    "reminderMinute": reminderMinute,
  };
}



CrpDrinkWaterPeriodInfo crpDrinkWaterPeriodInfoFromJson(String str) => CrpDrinkWaterPeriodInfo.fromJson(json.decode(str));
String crpDrinkWaterPeriodInfoToJson(CrpDrinkWaterPeriodInfo data) => json.encode(data.toJson());
class CrpDrinkWaterPeriodInfo {
  CrpDrinkWaterPeriodInfo({
    required this.enable,
    required this.startHour,
    required this.startMinute,
    required this.count,
    required this.period,
    required this.currentCups,
  });

  bool enable;
  int startHour;
  int startMinute;
  int count;
  int period;
  int currentCups;

  factory CrpDrinkWaterPeriodInfo.fromJson(Map<String, dynamic> json) => CrpDrinkWaterPeriodInfo(
    enable: json["enable"],
    startHour: json["startHour"],
    startMinute: json["startMinute"],
    count: json["count"],
    period: json["period"],
    currentCups: json["currentCups"],
  );

  Map<String, dynamic> toJson() => {
    "enable": enable,
    "startHour": startHour,
    "startMinute": startMinute,
    "count": count,
    "period": period,
    "currentCups": currentCups,
  };
}



CrpHandWashingPeriodInfo crpHandWashingPeriodInfoFromJson(String str) => CrpHandWashingPeriodInfo.fromJson(json.decode(str));
String crpHandWashingPeriodInfoToJson(CrpHandWashingPeriodInfo data) => json.encode(data.toJson());
class CrpHandWashingPeriodInfo {
  CrpHandWashingPeriodInfo({
    required this.enable,
    required this.startHour,
    required this.startMinute,
    required this.count,
    required this.period,
  });

  bool enable;
  int startHour;
  int startMinute;
  int count;
  int period;

  factory CrpHandWashingPeriodInfo.fromJson(Map<String, dynamic> json) => CrpHandWashingPeriodInfo(
    enable: json["enable"],
    startHour: json["startHour"],
    startMinute: json["startMinute"],
    count: json["count"],
    period: json["period"],
  );

  Map<String, dynamic> toJson() => {
    "enable": enable,
    "startHour": startHour,
    "startMinute": startMinute,
    "count": count,
    "period": period,
  };
}


CrpPillReminderInfo crpPillReminderInfoFromJson(String str) => CrpPillReminderInfo.fromJson(json.decode(str));

String crpPillReminderInfoToJson(CrpPillReminderInfo data) => json.encode(data.toJson());

class CrpPillReminderInfo {
  CrpPillReminderInfo({
    required this.id,
    required this.dateOffset,
    required this.name,
    required this.repeat,
    required this.reminderTimeList,
  });

  int id;
  int dateOffset;
  String name;
  int repeat;
  List<dynamic> reminderTimeList;

  factory CrpPillReminderInfo.fromJson(Map<String, dynamic> json) => CrpPillReminderInfo(
    id: json["id"],
    dateOffset: json["dateOffset"],
    name: json["name"],
    repeat: json["repeat"],
    reminderTimeList: List<dynamic>.from(json["reminderTimeList"].map((x) => x)),
  );

  Map<String, dynamic> toJson() => {
    "id": id,
    "dateOffset": dateOffset,
    "name": name,
    "repeat": repeat,
    "reminderTimeList": List<dynamic>.from(reminderTimeList.map((x) => x)),
  };
}



CrpContactInfo crpContactInfoFromJson(String str) => CrpContactInfo.fromJson(json.decode(str));
String crpContactInfoToJson(CrpContactInfo data) => json.encode(data.toJson());
class CrpContactInfo {
  CrpContactInfo({
    required this.id,
    required this.width,
    required this.height,
    required this.address,
    required this.name,
    required this.number,
    required this.avatar,
  });

  int id;
  int width;
  int height;
  int address;
  String name;
  String number;
  Uint8List? avatar;

  factory CrpContactInfo.fromJson(Map<String, dynamic> json) => CrpContactInfo(
    id: json["id"],
    width: json["width"],
    height: json["height"],
    address: json["address"],
    name: json["name"],
    number: json["number"],
    avatar: json["avatar"],
  );

  Map<String, dynamic> toJson() => {
    "id": id,
    "width": width,
    "height": height,
    "address": address,
    "name": name,
    "number": number,
    "avatar": avatar,
  };
}


// libaozhong: end